<template>
  <!--The QuestionList shows the questions that can be loaded an choosen from the template and displays
        self created question objects.-->
  <div>
    <div>
      <SearchBar @input="filterQuestions" @filterCleared="clearFilter" />
      <v-row
        :style="'height: ' + questionListHeight + 'px;'"
        id="scroll-target"
      >
        <v-col
          class="mx-auto question-list"
          :style="'background-color: ' + questionListBackgroundColor + ' ;'"
        >
          <template v-for="question in questionsToShow">
            <v-list-item :key="question.text">
              <Question :question="question" class="question-item" />
            </v-list-item>
            <v-divider :key="question.number" v-if="$vuetify.breakpoint.xs" />
          </template>
          <v-list-item v-if="$vuetify.breakpoint.smAndUp">
            <QuestionAddButton
              title="Neue Frage hinzufügen"
              @click.native="openAddQuestion"
            ></QuestionAddButton>
          </v-list-item>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
  import Question from "./Question";
  import SearchBar from "./SearchBar";
  import QuestionAddButton from "./QuestionAddButton";

  //loads the Question, SearchBar and the QuestionAddButton components to embed them in the template.
export default {
  name: "QuestionList",
  components: {
    Question,
    SearchBar,
    QuestionAddButton
  },
  data() {
    return {
      questionsToShow: this.$store.state.questions.question,
      questionFilterValue: ""
    };
  },
  methods: {
    //here can questions be filtered to find a special question.
    filterQuestions(event) {
      this.questionFilterValue = event;
      this.questionsToShow = this.questions.filter(question =>
        question.text
          .toLowerCase()
          .includes(this.questionFilterValue.toLowerCase())
      );
    },
    //to clear the filter.
    clearFilter() {
      this.filterQuestions("");
    },
    //to add a new self created question object.
    createNewQuestionObject: function() {
      this.$store.dispatch("addNewSelfCreatedQuestionObject", this.newQuestion);
    },
    //if the QuestionAdd component should be closed, this method shows the QuestionList immediately.
    openAddQuestion() {
      this.$store.dispatch("showQuestionListObject");
    }
  },
  computed: {
    //adjusts the height of the question list that depends on what advice is running PhysioForm
    questionListHeight: function() {
      if (this.$vuetify.breakpoint.lgAndUp) {
        return this.$vuetify.breakpoint.height - 114;
      } else if (this.$vuetify.breakpoint.smAndUp) {
        return 170;
      } else {
        return this.$vuetify.breakpoint.height - 200;
      }
    },
    //adjusts the background color of the question list.
    questionListBackgroundColor: function() {
      if (this.$vuetify.breakpoint.smAndUp) {
        return "#58A8A0";
      } else {
        return "white";
      }
    },
    questions: function() {
      return this.$store.state.questions.question;
    }
  }
};
</script>

<style scoped>
#scroll-target {
  overflow-x: hidden;
  overflow-y: scroll;
}

@media only screen and (min-width: 600px) {
  .question-item {
    border-radius: 15px;
    background-color: white;
  }

  .question-list {
    min-height: 170px;
  }
}
</style>
